【做题总结】顺子(双指针)


这道题考的细节挺多的:

  1. 数据规模:m的范围到2×10^9,我原本想用前缀和统计1至m范围空缺的牌数,但这个规模数组是很难容纳的。
  2. 输入的牌,可能有牌数重复的,所以要做去重和排序。
  3. 我在写代码的时候,一直被边界问题困扰了比较久,以及程序的整体思路也不太清晰。这里理了一下思路:
    ①预处理:对输入数组排序并去重,去除重复牌以减少无效计算。
    ②双指针初始化:设置左指针 l=0,右指针 i 从 1 开始遍历去重后的数组;定义 c 统计 l,i 区间内需要的鬼牌数(空缺数)。
    ③空缺数计算:遍历过程中,累加 l,i 区间内相邻牌的空缺数(公式:ai-ai-1-1)到 c。
    ④窗口收缩:若 c > k(空缺数超过鬼牌数),则右移左指针 l,并减去移出区间对应的空缺数,直到 c ≤ k。
    ⑤答案更新:计算剩余鬼牌数 r = k - c;当前窗口补全空缺后的基础长度为 ai-al+1,剩余鬼牌可向区间两侧扩展,最终长度需满足不超过 m;用 ans = max(ans, min(m, ai-al+1 + r - (l == 0))) 更新答案。
    ** 减 (l==0) 是因为 a0 是虚拟哨兵值(非有效牌),当 l=0 时,基础长度公式会多算 1,需用⑥该修正项抵消误差。
    输出结果:遍历结束后,输出最大顺子长度 ans。

AC代码:

cpp 复制代码
#include<bits/stdc++.h>
#define ll long long
using namespace std;
ll n,m,k,a[500005],ans,c;
int main(){
	cin>>n>>m>>k;
	for(int i=1;i<=n;i++) cin>>a[i];
	sort(a+1,a+n+1);
	int p=unique(a+1,a+n+1)-(a+1);
	a[0]=0;
	ll l=0;
	for(ll i=1;i<=p;i++){
		if(i>l) c+=a[i]-a[i-1]-1;
		while(c>k&&l<i){
			l++;
			c-=a[l]-a[l-1]-1;
		}
		ll r=k-c;
		if(r>=0) ans=max(ans,min(m,a[i]-a[l]+1+r-(l==0)));
	}
	cout<<ans;
	return 0;
} 
相关推荐
别动我齐刘海22 分钟前
Linux 系统调试学习1
linux·运维·服务器·c++·学习·机器学习·机器人
Nil2083 小时前
leetcode 198打家劫舍
算法·leetcode·职场和发展
Shaoshing4 小时前
前缀和与差分
java·数据结构·算法·前缀和·差分
loulanyue_4 小时前
构建房产认知决策智能:Harness底座与AI自进化的技术实践——读贝壳首席算法科学家尹俊希2026云栖专场演讲
人工智能·算法
碧海银沙音频科技研究院4 小时前
基于炬芯ATS录音卡BLE控制协议
人工智能·嵌入式硬件·算法·语音识别
jimy15 小时前
C++ 虚函数表:基类和派生类共用一张 vtable 吗?
开发语言·c++
爱吃提升5 小时前
Dev-C++ 5.11 C++断点调试完整教程
开发语言·c++
suhan5 小时前
【数据结构】三、栈和队列:6.链队列、双端队列、队列的应用(树的层次遍历、广度优先BFS、先来先服务FCFS)
数据结构·后端·算法
姜鱼问生5 小时前
Docker Volume 备份与恢复实战:不停机迁移数据
后端·算法·架构
suhan5 小时前
【数据结构】三、栈和队列:5.顺序队列(循环队列)(初始化,判空判满,入队,出队,实例)
数据结构·后端·算法